var webkam = {
  // (A) ИНИЦИАЛИЗИРОВАТЬ
  hVid : null, hSnaps :null, hTake : null, hSave : null,
  init : () => {
    // (A1) ПОЛУЧИТЬ HTML-ЭЛЕМЕНТЫ
    webkam.hVid = document.getElementById("kam-live"),
    webkam.hSnaps = document.getElementById("kam-snaps"),
    webkam.hTake = document.getElementById("kam-take"),
    webkam.hSave = document.getElementById("kam-save");

    // (A2) ПОЛУЧИТЬ РАЗРЕШЕНИЕ ПОЛЬЗОВАТЕЛЯ НА ДОСТУП К КАМЕРЕ
    navigator.mediaDevices.getUserMedia({ video: true })
    .then((stream) => {
      // ВЕБ-КАМЕРА "ПРЯМОЙ ТРАНСЛЯЦИИ" НА <ВИДЕО>
      webkam.hVid.srcObject = stream;

      // ВКЛЮЧИТЬ КНОПКИ
      webkam.hTake.onclick = webkam.take;
      webkam.hSave.onclick = webkam.save;
      webkam.hTake.disabled = false;
      webkam.hSave.disabled = false;
    })
    .catch((err) => { console.error(err); });
  },

  // (B) ПОМОЩНИК - ПРИВЯЗКА ВИДЕОКАДРА К ХОЛСТУ
  snap : () => {
    // (B1) СОЗДАТЬ НОВЫЙ ХОЛСТ
    let canvas = document.createElement("canvas"),
        ctx = canvas.getContext("2d"),
        vWidth = webkam.hVid.videoWidth,
        vHeight = webkam.hVid.videoHeight;

    // (B2) ЗАХВАТ ВИДЕОКАДРА НА ХОЛСТ
    canvas.width = vWidth;
    canvas.height = vHeight;
    ctx.drawImage(webkam.hVid, 0, 0, vWidth, vHeight);

    // (B3) ВЫПОЛНЕНО
    return canvas;
  },

  // (C) СДЕЛАЙТЕ СНИМОК - ПОМЕСТИТЕ ХОЛСТ В Обертку <DIV>
  take : () => {
    webkam.hSnaps.appendChild(webkam.snap());
  },

  // (D) СОХРАНИТЬ СНИМОК
  save : () => {
    // (D1) СДЕЛАТЬ СНИМОК, СОЗДАТЬ ССЫЛКУ ДЛЯ СКАЧИВАНИЯ
    let canvas = webkam.snap(),
        anchor = document.createElement("a");
    anchor.href = canvas.toDataURL("image/png");
    anchor.download = "snap.png";

    // (D2) "СКАЧАТЬ ПРИНУДИТЕЛЬНО" - МОЖЕТ НЕ ВСЕГДА РАБОТАТЬ!
    anchor.click();
    anchor.remove();
    canvas.remove();

    // (D3) SAFER - LET USERS MANUAL CLICK
    // anchor.appendChild(canvas);
    // webkam.hSnaps.appendChild(anchor);
  }
};
window.addEventListener("load", webkam.init);
